#include "SPM.h"


boolean_T FirstRun_SPM;

void SPM_Init(void)
{
  SOH_Init();
  BLC_Init();
  SOC_Init();
  FirstRun_SPM = true;
}


void SPM(void)
{

  static uint16_T spmd_Nr_cellNr;

  
  if (FirstRun_SPM)
  {
      spmd_Nr_cellNr =0;
  }
  spmd_Nr_cellNr = spmd_Nr_cellNr + 1;
  if (spmd_Nr_cellNr >= cmnc_num_cellUNum * 10)
  {
     spmd_Nr_cellNr = 0;
  }
  cand_Nr_cellNr = (uint16_T)(spmd_Nr_cellNr * 0.1) +1;
  
  SOH();
  BLC();
  if (!ihd_flg_urtRecFlt)
  {
    SOC();
  }

  
  cand_Q_cellCap = sohv_Q_cellCap[cand_Nr_cellNr-1];
  cand_V_chrgStartStat=sohv_V_chrgStartStatEo[cand_Nr_cellNr-1];
  cand_Q_reqCp   = blcv_Q_reqCpEo[cand_Nr_cellNr-1];
  cand_Q_totalCp = blcv_Q_totalCpEo[cand_Nr_cellNr-1];
  FirstRun_SPM =false;
}


